#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum BinaryArithmeticOperation {
    /// Calculates the angle measure between the x-axis and a ray from the origin to a point (input2, input1)
    /// in radians.
    /// Note the order of arguments.
    #[serde(rename = "ATAN2")]
    Atan2,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl BinaryArithmeticOperation {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            BinaryArithmeticOperation::Atan2 => "ATAN2",
            BinaryArithmeticOperation::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for BinaryArithmeticOperation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for BinaryArithmeticOperation {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for BinaryArithmeticOperation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<BinaryArithmeticOperation, conjure_object::plain::ParseEnumError> {
        match v {
            "ATAN2" => Ok(BinaryArithmeticOperation::Atan2),
            v => v.parse().map(|v| BinaryArithmeticOperation::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for BinaryArithmeticOperation {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<BinaryArithmeticOperation, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the BinaryArithmeticOperation enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
